<?php

namespace Drupal\fac\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configure example settings for this site.
 */
class FacSettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'fac_settings';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'fac.settings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('fac.settings');

    $form['key_interval'] = [
      '#type' => 'number',
      '#title' => $this->t('Key update interval'),
      '#default_value' => $config->get('key_interval'),
      '#description' => $this->t('To reduce the risk of information leakage a role-based hash/key is used in the json files URL. Enter the key update interval in seconds (defaults to one week).'),
    ];

    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->configFactory->getEditable('fac.settings')
      ->set('key_interval', $form_state->getValue('key_interval'))
      ->save();

    parent::submitForm($form, $form_state);
  }

}
